unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, SHDocVw, OleCtrls, DateUtils;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Memo2: TMemo;
    Button12: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    WebBrowser1: TWebBrowser;
    SaveDialog1: TSaveDialog;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    ComboBox2: TComboBox;
    RadioGroup1: TRadioGroup;
    Label3: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    TabSheet3: TTabSheet;
    Memo3: TMemo;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    PageControl2: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Button1: TButton;
    Label6: TLabel;
    Edit1: TEdit;
    Button6: TButton;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    procedure Button12Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
 Form1: TForm1;
 xml_filename: String;

implementation

uses Unit_NetworkTest;

{$R *.dfm}

 //Declarao de Funes disponiveis na transmissaoMDFe32dll.dll para transmisso de arquivos XML de MDFe
 //Declao de funes onde o contedo completo do XML a ser transmitido  passado como parmtro PChar
 function fncMDFeRecepcao     (sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeConsulta     (sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeRetRecepcao  (sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeStatusServico(sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeRecepcaoEvento   (sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeConsNaoEnc   (sXML: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): PChar; StdCall; external 'transmissaoMDFe32dll.dll';


 //Declao de funes onde  passado o path do XML a ser transmitido e indicado o path onde a dll salvar o retorno da transmisso
 //Nas funes declaradas (abaixo) a dll utiliza internamente as mesmas funes originais (acima) para fazer a carga do arquivo, transmisso e retorno
 function fncMDFeRecepcaoEventoPath (sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeRecepcaoPath     (sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeConsultaPath     (sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeRetRecepcaoPath  (sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeStatusServicoPath(sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';
 function fncMDFeConsNaoEncPath   (sXMLPath, RetornoPath: PChar; iUF, iTipo: integer; versaoDados: PChar; retorno_detalhado: Boolean; IgnoreInvalidCert: Boolean): integer; stdcall; external 'transmissaoMDFe32dll.dll';

 //Tabela de cdigos de UF conforme IBGE:
 //NORTE
 // RO-11-Rondnia
 // AC-12-Acre
 // AM-13-Amazonas
 // RR-14-Roraima
 // PA-15-Par
 // AP-16-Amap
 // TO-17-Tocantins
 //NORDESTE
 // MA-21-Maranho
 // PI-22-Piau
 // CE-23-Cear
 // RN-24-Rio Grande do Norte
 // PB-25-Paraba
 // PE-26-Pernambuco
 // AL-27-Alagoas
 // SE-28-Sergipe
 // BA-29-Bahia
 //SUDESTE
 // MG-31-Minas Gerais
 // ES-32-Esprito Santo
 // RJ-33-Rio de Janeiro
 // SP-35-So Paulo
 //SUL
 // PR-41-Paran
 // SC-42-Santa Catarina
 // RS-43-Rio Grande do Sul
 //Regio Centro-Oeste	PR
 // MS-50-Mato Grosso do Sul
 // MT-51-Mato Grosso
 // GO-52-Gois
 // DF-53-Distrito Federal
 
 //SCAN=Sistema de Contingncia do Ambiente Nacional (SCAN)
 //Sistema de contingncia usado quando os servidores de uma determinada UF encontram-se offline
 
 //SVAN=Sefaz Virtual AN (Ambiente Nacional)
 //Estados Emissores pela Sefaz Virtual AN (Ambiente Nacional): CE, ES, MA, PA, PI e RN.
 //Conforme listado em http://www.mdfe.fazenda.gov.br/portal/VerificacaoDeServicos/VerificacaoServicos.aspx
 
 //SVRS=Sefaz Virtual RS (Rio Grande do Sul)
 //Estados Emissores pela Sefaz Virtual RS (Rio Grande do Sul): AC, AL, AM, AP, DF, MS, PB, RJ, RO, RR, SC, SE e TO.
 //Conforme listado em http://www.mdfe.fazenda.gov.br/portal/VerificacaoDeServicos/VerificacaoServicos.aspx
 
 //DPEC = Declarao Prvia de Emisso em Contingncia
 //O arquivo XML de DPEC deve ser enviado para o Sistema de Contingncia Eletrnica  SCE via Web Service ou via upload atravs de pgina www.mdfe.fazenda.gov.br
 
//Seleciona XMl a ser transmitido
procedure TForm1.Button12Click(Sender: TObject);
begin
 //Diretrio inicial ser o diretrio onde a aplicao est executando
 opendialog1.InitialDir := ExtractFileDir(application.ExeName);

 //Abre caixa de seleo de arquivos
 if OpenDialog1.Execute then
  begin
   xml_filename := OpenDialog1.FileName;

   //Apresenta XML escolhido em modo browser
   WebBrowser1.Navigate(xml_filename);

   //Apresenta XML escolhido em modo texto
   memo1.Lines.LoadFromFile(xml_filename);

   PageControl1.ActivePageIndex := 1;
  end;
end;

//Esta funo recebe uma UF e retorna o cdigo da UF conforme tabela do IBGE acima
function Cod_UF_IBGE(MyUF: String): integer;
var
 i: integer;
const
 UF: array[1..30] of String[2] = ('RO','AC','AM','RR','PA','AP','TO','MA','PI','CE','RN','PB','PE',
                                  'AL','SE','BA','MG','ES','RJ','SP','PR','SC','RS','MS','MT','GO','DF','CO','VN','VR');
 Cod_IBGE: array[1..30] of integer = (11,12,13,14,15,16,17,21,22,23,24,25,26,
                                      27,28,29,31,32,33,35,41,42,43,50,51,52,53,-1,-2,-3);
begin
 result := -1;

 if trim(MyUF) = '' then
  exit;

 try
  for i := 0 to High(UF) do
   begin
    if MyUF = UF[i] then
     begin
      result := Cod_IBGE[i];
      break;
     end;
   end;
  except
   result := -1;
  end;
end;

function copy_SubStr(SrcStr: String; SubStr: String; Count: integer): String;
begin
 result := copy(SrcStr, pos(SubStr, SrcStr) + length(SubStr), Count);
end;

//--- Remove caracteres invalidos de uma ShortString ---
//Usage: "NotToRemoveStr" is the Char Array NOT to be removed, "FromStr" is the ShortString to be removed from
Function RemoveInvalid(NotToRemoveStr: String; FromStr: String): PChar;
var
 TempStr: String;
 Res: String;
 x: integer;
begin
 TempStr := UpperCase(FromStr);
 Res := '';
 for x := 1 to Length(TempStr) do
  begin
   if Pos(TempStr[x], NotToRemoveStr) <> 0 then
    Res := Res + FromStr[x];
  end;
 Result := PChar(Res);
end;

function RemoveAcento(Str: String): string;
const
 ComAcento = '';
 SemAcento = 'aaeouaoaeioucuAAEOUAOAEIOUCU';
 AlfaArray = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789.;,<>?/[]{}*&^%$#@!_+-="`~|\:';
var
   x: Integer;
begin;
 for x := 1 to Length(Str) do
  begin
   if Pos(Str[x],ComAcento) <> 0 then
    Str[x] := SemAcento[Pos(Str[x], ComAcento)];
  end;

 //Str := RemoveInvalid(AlfaArray, Str);      //TODO: Esta linha foi comentada pois estava removendo aspas simples q apareciam em alguns arquivos, exemplo: versao='1.00'
 Result := Str;
end;

//Transmite XML selecionado
{
 Descrio dos parmetros:
 sXML : PChar;
   Contedo do XML a ser transmitido
 iUF: Integer;
   Cdigo da Unidade da Federao para a qual deseja fazer a transmisso conforme tabela IBGE
   Os dados sero enviados para a UF indicada ou para o SEFAZ Virtual caso a UF no d suporte conforme tabela:
     Estados Emissores pela Sefaz Virtual RS (VR): AC, AL, AM, AP, MS, PB, RJ, RR, SC, SE e TO
     Estados Emissores pela Sefaz Virtual AN (NR): CE, ES, MA, PA, PI, PR e RN
 iTipo: integer;
   Opo ainda no implementada
   Consultar item 9 do manual de integrao
   As Secretarias de Fazenda Estaduais devero manter dois ambientes para recepo de MDFe.
   O ambiente de homologao  especfico para a realizao de testes e integrao das
   aplicaes do contribuinte durante a fase de implementao e adequao do sistema de
   emisso de MDF-e do contribuinte.
   A autorizao para emisso de MDF-e no ambiente de produo fica condicionada  prvia
   aprovao das equipes de TI e de negcios da Secretaria de Fazenda, que dever avaliar a
   adequao, comportamento e performance do sistema de emisso de MDF-e do contribuinte
   interessado no ambiente de homologao.
 versao: String;
   Consultar item 3.4.1 do manual de integrao
   Verso do leiaute de transmisso (1.02)
 versaoDados: String
   Consultar item 3.4.1 do manual de integrao
   O campo versaoDados deve conter a informao da verso do leiaute da estrutura XML
   armazenada na rea de dados da mensagem.
}
procedure TForm1.Button1Click(Sender: TObject);
var
 MyiUF, MyiTipo, i: Integer;
 MysXML, MyversaoDados: PChar;
 datahora_ini, datahorafim: TDateTime;
 retorno: Pchar;
 mystr: String;
begin
 try
  datahora_ini := now;

  //Atribue valores das variveis q sero passadas como parmetro durante a transmisso
  MyiUF         := Cod_UF_IBGE(combobox1.text);                 //Consultar Anexo VII  Tabelas de UF, Municpio e Pas do Manual de Integrao
  MyiTipo       := combobox2.ItemIndex + 1;                     //1  Produo / 2 - Homologao
  MysXML        := PChar(memo1.Lines.Text);                     //Contedo XML a ser transmitido
  MyversaoDados := PChar(copy_SubStr(MysXML, 'versao="', 4));   //verso do leiaute da estrutura XML informada na rea de dados da mensagem

  //Realiza a chamada da funo da dll de acordo com o tipo de transao escolhida
  //Consulte Manual de Integrao para informaes referentes ao valores dos parmetros verso e versaoDados no cabealho da transmisso
  retorno := '';
  case radiogroup1.ItemIndex of
   0: retorno := fncMDFeRecepcao     (MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
   1: retorno := fncMDFeConsulta     (MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
   2: retorno := fncMDFeRetRecepcao  (MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
   3: retorno := fncMDFeStatusServico(MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
   4: retorno := fncMDFeRecepcaoEvento   (MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
   5: retorno := fncMDFeConsNaoEnc   (MysXML, MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked);
  end;

  //Este loop foi necessrio pois o retorno do tipo PChar vem com #0 ao final. Isso fazia com q o ultimo caractere '>' sumisse ao converter PChar para String

  mystr := '';
  i := 0;
  while retorno[i] <> #0 do
   begin
    mystr := mystr + retorno[i];
    inc(i);
   end;

  memo2.Lines.text := mystr;

  //memo2.Lines.text := retorno;

  datahorafim := now;
 except
  showmessage('ATENAO: Erro durante a transmisso');
  exit;
 end;

 showmessage('XML transmitido com sucesso. Verifique o retorno para informaes de retorno');

 label5.caption := 'Arquivo transmitido em ' + inttostr(SecondsBetween(datahorafim, datahora_ini)) +  'segundos';
end;

{
function RemoveAcento(Str: string): string;
const
  ComAcento = '';
  SemAcento = 'aaeouaoaeioucuAAEOUAOAEIOUCU';
var
   x: Integer;
begin;
  for x := 1 to Length(Str) do
   if Pos(Str[x],ComAcento) <> 0 then
    Str[x] := SemAcento[Pos(Str[x], ComAcento)];
  Result := Str;
end;
}

//Salva arquivo de retorno
procedure TForm1.Button2Click(Sender: TObject);
//var
// UTF8_Str: String;       << variavel nao usada
begin
 try
  //Diretrio inicial ser o diretrio onde a aplicao est executando
  savedialog1.InitialDir := ExtractFileDir(application.ExeName);

  //Concatena nome para arquivo de retorno
  SaveDialog1.FileName := 'retorno_' + combobox1.Text + '_' + ExtractFileName(xml_filename);

  //Salva arquivo de retorno
  if savedialog1.Execute then
   begin
    //Alguns arquivos de retorno da SEFAZ como o de consulta de de status do servio so retornados com acentuao o que no permite abrir os mesmos no browser
    //Esta funo remove tais acentos e elimina o problema
    if checkbox1.Checked then
     memo2.lines.Text := RemoveAcento(memo2.lines.Text);

    //Alteraes para realizar salvamento em formato UTF-8
    //UTF8_Str := Memo2.Lines.Text;
    //UTF8_Str := UTF8Encode(UTF8_Str);
    //UTF8_Str := char($EF) + char($BB) + char($BF) + UTF8_Str;   //adding BOM
    //Memo2.Lines.Text := UTF8_Str;

    //Salvando arquivo
    memo2.Lines.SaveToFile(savedialog1.filename);
   end;
 except
  showmessage('ATENAO: Erro durante o salvamento do arquivo de retorno');
  exit;
 end;

 showmessage('Arquivo de retorno salvo com sucesso.' + #13#10 +
             'Consulte os demos respectivos localizados na pasta Geracao_XML paa informaes sobre como ABRIR e manipular os XMLs de retorno');
end;

//Sistema volta a solicitar que o usurio selecione o certificado desejado para a assinatura
//Esta funcionalidade pode ser implementada em seu aplicativo final para desfazer a opo implementada na tela da dll
procedure TForm1.Button3Click(Sender: TObject);
var
 myfilename: String;
begin
 try
  //Configura o diretrio onde se encontra o arquivo que armazena o ndice
  //Da forma que est implementada aqui s funciona se a dll estiver localizada no mesmo diretrio do .exe
  myfilename := ExtractFilePath(application.ExeName) + '\DefCertificado.res';

  //testa se arquivo existe
  if fileexists(myfilename) then
   begin
    //exclue o arquivo q armazena o indice
    //Usurio logado no windows deve ter permisses sobre o diretrio e o arquivo em questo
    DeleteFile(myfilename);

    showmessage('Arquivo' + myfilename + 'excludo. O sistema voltar a solicitar que o usurio selecione o certificado desejado para a assinatura');
   end;
 except                          
  showmessage('Erro durante excluso do arquivo ' + myfilename)
 end;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 memo1.lines.Clear;
 memo2.lines.clear;
end;


//Os testes implementados nesta funo podem ser utilizados antes de se tentar o acesso aos webservices
//de forma a garantir que o computador est conectado e evitar erros de transmisso
procedure TForm1.Button5Click(Sender: TObject);
var
 flags : DWORD;
begin
 if IsNetworkAlive(flags) = 0 then
  ShowMessage('Nenhum tipo de conexo de rede detectada, Ok.')
 else
  begin
   if (flags and NETWORK_ALIVE_LAN) <> 0 then
    ShowMessage('connected to a local area network');

   if (flags and NETWORK_ALIVE_WAN) <> 0 then
    ShowMessage('connected to a wide area network');

   if (flags and NETWORK_ALIVE_AOL) <> 0 then
    ShowMessage('connected to an aol network');

   if (flags and INTERNET_CONNECTION_MODEM) <> 0 then
    ShowMessage('connected to a modem');
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
 MyiUF, MyiTipo: Integer;
 MysXML, MyversaoDados: PChar;
 datahora_ini, datahorafim: TDateTime;
begin
 try
  datahora_ini := now;

  //Atribue valores das variveis q sero passadas como parmetro durante a transmisso
  MyiUF         := Cod_UF_IBGE(combobox1.text);                 //Consultar Anexo VII  Tabelas de UF, Municpio e Pas do Manual de Integrao
  MyiTipo       := combobox2.ItemIndex + 1;                     //1  Produo / 2 - Homologao
  MysXML        := PChar(memo1.Lines.Text);                     //Contedo XML a ser transmitido
  MyversaoDados := PChar(copy_SubStr(MysXML, 'versao="', 4));   //verso do leiaute da estrutura XML informada na rea de dados da mensagem

  //Realiza a chamada da funo da dll de acordo com o tipo de transao escolhida
  //Consulte Manual de Integrao para informaes referentes ao valores dos parmetros verso e versaoDados no cabealho da transmisso
  case radiogroup1.ItemIndex of
   0: memo2.Lines.Text := inttostr(fncMdfeRecepcaoPath     (PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
   1: memo2.Lines.Text := inttostr(fncMdfeConsultaPath     (PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
   2: memo2.Lines.Text := inttostr(fncMdfeRetRecepcaoPath  (PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
   3: memo2.Lines.Text := inttostr(fncMdfeStatusServicoPath(PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
   4: memo2.Lines.Text := inttostr(fncMdfeRecepcaoEventoPath   (PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
   5: memo2.Lines.Text := inttostr(fncMdfeConsNaoEncPath   (PChar(xml_filename), PChar(edit1.text), MyiUF, MyiTipo, MyversaoDados, checkbox3.checked, checkbox4.checked));
  end;

  datahorafim := now;
 except
  showmessage('ATENAO: Erro durante a transmisso');
  exit;
 end;

 showmessage('Verifique o retorno para informaes de retorno');

 label5.caption := 'Tempo decorrido ' + inttostr(SecondsBetween(datahorafim, datahora_ini)) +  'segundos';

end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 //Se os servios de Contigncia DPEC forem selecionados no  preciso indica UF e o envio tb no ser via SCAN, portanto desabilita componentes na tela do demo!
 if (RadioGroup1.ItemIndex = 7) or (RadioGroup1.ItemIndex = 8) then
  begin
   label1.Enabled       := false;
   combobox1.Enabled    := false;
  end
 else
  begin
   label1.Enabled       := true;
   combobox1.Enabled    := true;
  end;


end;

end.



